Bug 1890878 - libxml2 fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats
Summary: libxml2 fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN macro ...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: libxml2
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Igor Raits
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-10-23 07:49 UTC by Tomáš Hrnčiar
Modified: 2020-11-19 20:17 UTC (History)
6 users (show)

Fixed In Version: libxml2-2.9.10-9.fc34 libxml2-2.9.10-9.eln105
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-11-12 11:54:15 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-10-23 07:49:36 UTC
libxml2 fails to build with Python 3.10.0a1.

make[2]: Leaving directory '/builddir/build/BUILD/libxml2-2.9.10/py3/python/tests'
test.xml:1: parser error : Couldn't find end of Start Tag foo
<foo
    ^
SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "/builddir/build/BUILD/libxml2-2.9.10/py3/python/tests/../../../python/tests/push.py", line 9, in <module>
    ctxt.parseChunk("/>", 2, 1)
  File "/builddir/build/BUILD/libxml2-2.9.10/python/libxml2.py", line 5101, in parseChunk
    ret = libxml2mod.xmlParseChunk(self._o, chunk, size, terminate)
SystemError: <built-in function xmlParseChunk> returned a result with an error set

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01715877-libxml2/

For all our attempts to build libxml2 with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/libxml2/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Miro Hrončok 2020-10-23 08:18:10 UTC
https://docs.python.org/3.10/whatsnew/3.10.html#id2

The PY_SSIZE_T_CLEAN macro must now be defined to use PyArg_ParseTuple() and Py_BuildValue() formats which use #: es#, et#, s#, u#, y#, z#, U# and Z#. See Parsing arguments and building values and the PEP 353.

https://docs.python.org/3.10/c-api/arg.html#arg-parsing
https://www.python.org/dev/peps/pep-0353
https://bugs.python.org/issue40943

Comment 2 Victor Stinner 2020-11-09 17:26:11 UTC
I reported the issue to upstream: https://gitlab.gnome.org/GNOME/libxml2/-/issues/203

And I proposed a fix: https://gitlab.gnome.org/GNOME/libxml2/-/merge_requests/87

Comment 3 Victor Stinner 2020-11-10 14:02:01 UTC
I proposed to https://src.fedoraproject.org/rpms/libxml2/pull-request/10 to backport my fix and fix the package (always regenerate the 3 Python generated files).

Comment 5 Fedora Update System 2020-11-12 11:54:15 UTC
FEDORA-2020-576ed43594 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 6 Fedora Update System 2020-11-12 12:09:16 UTC
FEDORA-2020-160ee73cea has been pushed to the Fedora ELN stable repository.
If problem still persists, please make note of it in this bug report.

Comment 7 Victor Stinner 2020-11-19 20:17:22 UTC
> I proposed to https://src.fedoraproject.org/rpms/libxml2/pull-request/10 to backport my fix and fix the package (always regenerate the 3 Python generated files).

FYI my PR has been merged upstream:
* https://gitlab.gnome.org/GNOME/libxml2/-/commit/f42a0524c693a6d52e95a37c9cf04df1be48262c
* https://gitlab.gnome.org/GNOME/libxml2/-/commit/ac5e99911a45ad6f57a6aa7b33fd2de9da72aa72


Note You need to log in before you can comment on or make changes to this bug.